#ifndef _CEGONET_H_INCLUDED_
#define _CEGONET_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// CegoNet.h
// ---------
// Cego net client API
//
// Design and Implementation by Bjoern Lemke
//
// (C)opyright 2010-2013 Bjoern Lemke
//
// INTERFACE MODULE
//
// Class: CegoNet
// 
// Description: 
//
// Status: QG-2.6
//
///////////////////////////////////////////////////////////////////////////////

// base includes
#include <lfcbase/Chain.h>
#include <lfcbase/ListT.h>
#include <lfcbase/NetHandler.h>

// cego includes
#include "CegoField.h"
#include "CegoDbHandler.h"

class CegoNet {

 public:

    CegoNet(CegoDbHandler::ProtocolType protType, const Chain& logFile, const Chain& logMode );
    ~CegoNet();
    
    void connect(const Chain& serverName, int port, const Chain& tableSet, const Chain& user, const Chain& pwd);
    long doQuery(const Chain& query);
    bool fetchData(const ListT<CegoField>& schema, ListT<CegoFieldValue>& fvl);

    bool isFetchable();
    void abortQuery();
    void resetQuery();
    bool wasReset();
    
    const Chain& getMsg();
    long getAffected();
    void getSchema(ListT<CegoField>& schema);
    void getProcResult(ListT<CegoProcVar>& outParamList, CegoFieldValue& retValue);


    void disconnect();

private:

    CegoDbHandler::ProtocolType _protType;
    Chain _logFile;
    Chain _logMode;

    NetHandler* _pN;
    CegoDbHandler* _pSH;
    CegoModule* _pModule;

    bool _isFetchable;
};

#endif




